package com.boot.bus.sqlsync.emqx;

import org.springframework.integration.annotation.MessagingGateway;
import org.springframework.integration.mqtt.support.MqttHeaders;
import org.springframework.messaging.handler.annotation.Header;
import org.springframework.stereotype.Component;

/**
 * @ProjectName: YeeFireDataProcessRoot
 * @Package: com.yeejoin.dataprocess.common.emqtt
 * @ClassName: MqttServer
 * @Author: Jianqiang Gao
 * @Description: MqttServer
 * @Date: 2021/3/23 15:58
 * @Version: 1.0
 */
@Component
@MessagingGateway(defaultRequestChannel = "mqttOutboundChannel")
public interface MqttServer {

    /**
     * 通道发送消息
     * @param topic 主题
     * @param data 数据
     */
    void sendToMqtt(@Header(MqttHeaders.TOPIC) String topic, String data);

}