package com.boot.bus.sqlsync.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.boot.bus.sqlsync.service.infc.IContingencyPlanInstance;
import com.yeejoin.amos.fas.common.enums.DataSyncOperationEnum;
import com.yeejoin.amos.fas.common.enums.DataSyncTypeEnum;
import com.yeejoin.amos.fas.dao.entity.ContingencyPlanInstance;
import com.yeejoin.amos.fas.datasync.DataSyncMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @ProjectName: YeeFireDataProcessRoot
 * @Package: com.yeejoin.dataprocess.service.impl
 * @ClassName: SyncMqttMessageService
 * @Author: Jianqiang Gao
 * @Description: 同步mqtt消息
 * @Date: 2021/7/8 16:54
 * @Version: 1.0
 */
@Service("SyncMqttMessageService")
public class SyncMqttMessageService {

    @Autowired
    private IContingencyPlanInstance contingencyPlanInstance;

    @Autowired
    private RedisTemplate redisTemplate;

    /**
     * @param message
     */
    public void syncData(DataSyncMessage message) {
        DataSyncTypeEnum type = message.getType();
        DataSyncOperationEnum operation = message.getOperation();
        List<Serializable> data = message.getData();
        assert message.getType() != null && message.getOperation() != null : "同步消息体信息不足";
        if (data == null || data.isEmpty()) {
            return;
        }
        switch (type) {
            case CONTINGENCY_PLAN_INSTANCE: {
                switch (operation) {
                    case DELETE: {
                        contingencyPlanInstance.astDeleteByIds(data.stream().map(x -> ((JSONObject) x).toJavaObject(ContingencyPlanInstance.class).getId()).collect(Collectors.toList()));
                        break;
                    }
                    default: {
                        contingencyPlanInstance.astSaveOrUpdateBatch(data.stream().map(x -> ((JSONObject) x).toJavaObject(ContingencyPlanInstance.class)).collect(Collectors.toList()));
                    }
                }
                break;
            }
            default:
//                Async.shutDown();
        }
    }
}